    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * PinNeedle.java
    029     * --------------
    030     * (C) Copyright 2002-2005, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: MiddlePinNeedle.java,v 1.4.2.2 2005/10/25 20:50:49 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 27-Mar-2003 : Implemented Serializable (DG);
    042     * 09-Sep-2003 : Added equals() method (DG);
    043     * 08-Jun-2005 : Implemented Cloneable (DG);
    044     *
    045     */
    046
    047    package org.jfree.chart.needle;
    048
    049    import java.awt.Graphics2D;
    050    import java.awt.geom.Area;
    051    import java.awt.geom.Ellipse2D;
    052    import java.awt.geom.GeneralPath;
    053    import java.awt.geom.Point2D;
    054    import java.awt.geom.Rectangle2D;
    055    import java.io.Serializable;
    056
    057    /**
    058     * A needle that is drawn as a pin shape.
    059     *
    060     * @author Bryan Scott
    061     */
    062    public class MiddlePinNeedle extends MeterNeedle
    063                                 implements Cloneable, Serializable {
    064
    065        /** For serialization. */
    066        private static final long serialVersionUID = 6237073996403125310L;
    067
    068        /**
    069         * Draws the needle.
    070         *
    071         * @param g2  the graphics device.
    072         * @param plotArea  the plot area.
    073         * @param rotate  the rotation point.
    074         * @param angle  the angle.
    075         */
    076        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    077                                  Point2D rotate, double angle) {
    078
    079            Area shape;
    080            GeneralPath pointer = new GeneralPath();
    081
    082            int minY = (int) (plotArea.getMinY());
    083            //int maxX = (int) (plotArea.getMaxX());
    084            int maxY = (int) (plotArea.getMaxY());
    085            int midY = ((maxY - minY) / 2) + minY;
    086
    087            int midX = (int) (plotArea.getMinX() + (plotArea.getWidth() / 2));
    088            //int midY = (int) (plotArea.getMinY() + (plotArea.getHeight() / 2));
    089            int lenX = (int) (plotArea.getWidth() / 10);
    090            if (lenX < 2) {
    091                lenX = 2;
    092            }
    093
    094            pointer.moveTo(midX - lenX, midY - lenX);
    095            pointer.lineTo(midX + lenX, midY - lenX);
    096            pointer.lineTo(midX, minY);
    097            pointer.closePath();
    098
    099            lenX = 4 * lenX;
    100            Ellipse2D circle = new Ellipse2D.Double(midX - lenX / 2,
    101                                                    midY - lenX, lenX, lenX);
    102
    103            shape = new Area(circle);
    104            shape.add(new Area(pointer));
    105            if ((rotate != null) && (angle != 0)) {
    106                /// we have rotation
    107                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    108                shape.transform(getTransform());
    109            }
    110
    111            defaultDisplay(g2, shape);
    112
    113        }
    114
    115        /**
    116         * Tests another object for equality with this object.
    117         *
    118         * @param object  the object to test.
    119         *
    120         * @return A boolean.
    121         */
    122        public boolean equals(Object object) {
    123            if (object == null) {
    124                return false;
    125            }
    126            if (object == this) {
    127                return true;
    128            }
    129            if (super.equals(object) && object instanceof MiddlePinNeedle) {
    130                return true;
    131            }
    132            return false;
    133        }
    134
    135        /**
    136         * Returns a clone of this needle.
    137         *
    138         * @return A clone.
    139         */
    140        public Object clone() throws CloneNotSupportedException {
    141            return super.clone();
    142        }
    143
    144    }